// DeCross.dll v0.0.01 Copyright(C) 2003 minamina
// Avisynth Plugin - Cross Color Reduction (YUY2 and YV12 Only)

// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

#ifndef _DE_CROSS_H
#define _DE_CROSS_H

#include <windows.h>
#pragma warning (push, 1)
#include <boost/shared_ptr.hpp>
#include <boost/lexical_cast.hpp>
#include "avisynth.h"
#pragma warning (pop)

class DeCross : public GenericVideoFilter
{
public:
	static void PluginInit(IScriptEnvironment *env)
	{ env->AddFunction(GetName(), GetParams(), Create, 0); }

	DeCross(PClip _child, const int nYThreshold, const int nNoiseThreshold,
		const int nMargin, const bool bDebug, IScriptEnvironment* env);

private:
	static AVSValue __cdecl Create(AVSValue args, void* /*user_data*/, IScriptEnvironment *env)
	{ return new DeCross(args[0].AsClip(), args[1].AsInt(30), args[2].AsInt(60),
							args[3].AsInt(1), args[4].AsBool(false), env); }
	static const char *GetName() { return "DeCross"; }
	static const char *GetParams() { return "c[ThresholdY]i[Noise]i[Margin]i[Debug]b"; }

	PVideoFrame __stdcall GetFrame(int n, IScriptEnvironment *env);
	int m_nYThreshold;
	int m_nNoiseThreshold;
	int m_nMargin;
	bool m_bDebug;

	PVideoFrame DeCross_YUY2(int n, IScriptEnvironment *env);
	inline void Diff_YUY2(const BYTE* pDiff0, const BYTE* pDiff1, const int nPos, int& nMiniDiff, const BYTE* &pMiniDiff);
	void EdgeCheck_YUY2(const BYTE* pSrc, BYTE* pEdgeBuffer, const int nRowSize);
	PVideoFrame DeCross_YV12(int n, IScriptEnvironment *env);
	inline bool Diff_YV12(const BYTE* pDiff0, const BYTE* pDiff1, const int nPos, int& nMiniDiff);
	void EdgeCheck_YV12(const BYTE* pSrc, BYTE* pEdgeBuffer, const int nRowSizeU);
};

#endif // _DE_CROSS_H
